#include "Hack.h"
#include <stdio.h>
#include <math.h>
#include <TlHelp32.h>
#include <Psapi.h>
#include <tchar.h>

DWORD FindProcessByName(const char *procName) {
    PROCESSENTRY32 entry;
    entry.dwSize = sizeof(PROCESSENTRY32);

    HANDLE snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, NULL);

    if (Process32First(snapshot, &entry) == TRUE) {
        while (Process32Next(snapshot, &entry) == TRUE) {
            if (stricmp(entry.szExeFile, procName) == 0) {
				CloseHandle(snapshot);
				return entry.th32ProcessID;
            }
        }
    }

    CloseHandle(snapshot);
	return 0;
}

void EnableDebugPriv() {
    HANDLE hToken;
    LUID luid;
    TOKEN_PRIVILEGES tkp;

    OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken);

    LookupPrivilegeValue(NULL, SE_DEBUG_NAME, &luid);

    tkp.PrivilegeCount = 1;
    tkp.Privileges[0].Luid = luid;
    tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

    AdjustTokenPrivileges(hToken, false, &tkp, sizeof(tkp), NULL, NULL);

    CloseHandle(hToken); 
}

DWORD GetModuleBase(DWORD dwProcessIdentifier, TCHAR *lpszModuleName) { 
   HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, dwProcessIdentifier); 
   int tries = 20;
   while (tries > 0) {
	   if (hSnapshot == INVALID_HANDLE_VALUE) {
		   hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, dwProcessIdentifier);
		   Sleep(200);
		   tries--;
	   } else {
			tries = 0;
	   }
   }
   if (hSnapshot == INVALID_HANDLE_VALUE) {
		printf("Invalid process handle\n");
		return 0;
   }
   
   DWORD dwModuleBaseAddress = 0;
      MODULEENTRY32 ModuleEntry32 = {0}; 
      ModuleEntry32.dwSize = sizeof(MODULEENTRY32); 
      if (Module32First(hSnapshot, &ModuleEntry32)) { 
         do {
            if (_tcscmp(ModuleEntry32.szModule, lpszModuleName) == 0) { 
               dwModuleBaseAddress = (DWORD)ModuleEntry32.modBaseAddr; 
               break; 
            } 
         } while(Module32Next(hSnapshot, &ModuleEntry32)); 
      } 
      CloseHandle(hSnapshot); 

   return dwModuleBaseAddress; 
}

DWORD FindAddressByBytes(HANDLE hProc,const char *b,int numBytes,const bool *wildCards) {
	unsigned char *pos = NULL;
	MEMORY_BASIC_INFORMATION blockInfo;
	int result = sizeof(blockInfo);
	int cMP = 0;//current memory block position
	int cB = 0;//current byte array position
	DWORD addr = -1;
	char *mem;

	while (result == sizeof(blockInfo)) {
		result = VirtualQueryEx(hProc,pos,&blockInfo,sizeof(MEMORY_BASIC_INFORMATION));
		if (blockInfo.State == MEM_FREE || blockInfo.State == MEM_RESERVE || blockInfo.Protect == PAGE_NOACCESS) {
			pos += blockInfo.RegionSize;
			continue;
		}

		mem = new char[blockInfo.RegionSize];
		ReadProcessMemory(hProc,(LPVOID)blockInfo.BaseAddress,(LPVOID)mem,blockInfo.RegionSize,NULL);
		while (cMP != blockInfo.RegionSize) {
			if (wildCards != NULL) {
				if (wildCards[cB]) {
					cMP++;
					cB++;
					if (cB == numBytes) {
						return addr;
					}
					continue;
				}
			}
			if (mem[cMP] == b[cB]) {
				if (cB == 0) {
					addr = cMP+(unsigned)blockInfo.BaseAddress;
				}
				cB++;
				if (cB == numBytes) {
					return addr;
				}
			} else {
				cB = 0;
			}

			cMP++;
		}

		delete mem;
		cMP = 0;
		cB = 0;
		pos += blockInfo.RegionSize;
	}

	return -1;
}

int FindAddresssByBytes(HANDLE hProc,const char *b,int numBytes,DWORD *addressBuf,int bufferSize,const bool *wildCards) {
	unsigned char *pos = NULL;
	MEMORY_BASIC_INFORMATION blockInfo;
	int result = sizeof(blockInfo);
	int cA = 0;//current address index
	int cMP = 0;//current memory block position
	int cB = 0;//current byte array position
	char *mem;

	while (result == sizeof(blockInfo)) {
		result = VirtualQueryEx(hProc,pos,&blockInfo,sizeof(MEMORY_BASIC_INFORMATION));
		if (blockInfo.State == MEM_FREE || blockInfo.State == MEM_RESERVE || blockInfo.Protect == PAGE_NOACCESS) {
			pos += blockInfo.RegionSize;
			continue;
		}

		mem = new char[blockInfo.RegionSize];
		ReadProcessMemory(hProc,(LPVOID)blockInfo.BaseAddress,(LPVOID)mem,blockInfo.RegionSize,NULL);
		while (cMP != blockInfo.RegionSize) {
			if (wildCards != NULL) {
				if (wildCards[cB]) {
					cMP++;
					cB++;
					if (cB == numBytes) {
						cA++;
						if (cA == bufferSize) {
							return cA;
						}
						cB = 0;
					}
					continue;
				}
			}
			if (mem[cMP] == b[cB]) {
				if (cB == 0) {
					addressBuf[cA] = cMP+(unsigned)blockInfo.BaseAddress;
				}
				cB++;
				if (cB == numBytes) {
					cA++;
					if (cA == bufferSize) {
						return cA;
					}
					cB = 0;
				}
			} else {
				cB = 0;
			}

			cMP++;
		}

		delete mem;
		cMP = 0;
		cB = 0;
		pos += blockInfo.RegionSize;
	}

	return cA;
}


int ReadInt(HANDLE hProc,DWORD addr) {
	int iBuf[1];
	ReadProcessMemory(hProc,(LPVOID)addr,(LPVOID)iBuf,4,NULL);
	return iBuf[0];
}
short ReadShort(HANDLE hProc,DWORD addr) {
	short sBuf[1];
	ReadProcessMemory(hProc,(LPVOID)addr,(LPVOID)sBuf,2,NULL);
	return sBuf[0];
}
char ReadByte(HANDLE hProc,DWORD addr) {
	char cBuf[1];
	ReadProcessMemory(hProc,(LPVOID)addr,(LPVOID)cBuf,1,NULL);
	return cBuf[0];
}
float ReadFloat(HANDLE hProc,DWORD addr) {
	float buf[1];
	ReadProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,4,NULL);
	return buf[0];
}
double ReadDouble(HANDLE hProc,DWORD addr) {
	double buf[1];
	ReadProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,8,NULL);
	return buf[0];
}
char *ReadBytes(HANDLE hProc,DWORD addr,int nBytes) {
	char *buf = new char[nBytes];
	ReadProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,nBytes,NULL);
	return buf;
}

void WriteInt(HANDLE hProc,DWORD addr,int val) {
	int buf[1] = {val};
	WriteProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,4,NULL);
}
void WriteShort(HANDLE hProc,DWORD addr,short val) {
	short buf[1] = {val};
	WriteProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,2,NULL);
}
void WriteByte(HANDLE hProc,DWORD addr,char val) {
	char buf[1] = {val};
	WriteProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,1,NULL);
}
void WriteFloat(HANDLE hProc,DWORD addr,float val) {
	float buf[1] = {val};
	WriteProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,4,NULL);
}
void WriteDouble(HANDLE hProc,DWORD addr,double val) {
	double buf[1] = {val};
	WriteProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,8,NULL);
}
void WriteBytes(HANDLE hProc,DWORD addr,char *bytes,int nBytes) {
	WriteProcessMemory(hProc,(LPVOID)addr,(LPVOID)bytes,nBytes,NULL);
}

void MacroMouseMove(int x, int y, long timeMs) {
	POINT p;
	GetCursorPos(&p);

	int tT = ceil(timeMs/20.0f);
	int tC = 0;

	int mX = (x-p.x);
	int mY = (y-p.y);

	while (tC != tT) {
		tC++;
		float tP = (float)tC/(float)tT;
		SetCursorPos((tP*mX)+p.x,(tP*mY)+p.y);

		Sleep(20);
	}
}
void MacroMousePos(int x,int y) {
	SetCursorPos(x,y);
}
void MacroMouseClick(short button, long delayMs) {
	MacroMouseButtonDown(button);
	Sleep(delayMs);
	MacroMouseButtonUp(button);
}
void MacroMouseButtonDown(short button) {
	INPUT i;
	i.type = INPUT_MOUSE;
	switch (button) {
		case 0:
			i.mi.dwFlags = MOUSEEVENTF_LEFTDOWN;
			break;
		case 1:
			i.mi.dwFlags = MOUSEEVENTF_MIDDLEDOWN;
			break;
		case 2:
			i.mi.dwFlags = MOUSEEVENTF_RIGHTDOWN;
			break;
	}
	SendInput(1,&i,sizeof(INPUT));
}
void MacroMouseButtonUp(short button) {
	INPUT i;
	i.type = INPUT_MOUSE;
	switch (button) {
		case 0:
			i.mi.dwFlags = MOUSEEVENTF_LEFTUP;
			break;
		case 1:
			i.mi.dwFlags = MOUSEEVENTF_MIDDLEUP;
			break;
		case 2:
			i.mi.dwFlags = MOUSEEVENTF_RIGHTUP;
			break;
	}
	SendInput(1,&i,sizeof(INPUT));
}
void MacroKeyDown(char keyCode) {
	INPUT i;
	i.type = INPUT_KEYBOARD;

	i.ki.wVk = keyCode;
	i.ki.dwFlags = 0;

	SendInput(1,&i,sizeof(INPUT));
}
void MacroKeyUp(char keyCode) {
	INPUT i;
	i.type = INPUT_KEYBOARD;

	i.ki.wVk = keyCode;
	i.ki.dwFlags = KEYEVENTF_KEYUP;

	SendInput(1,&i,sizeof(INPUT));
}
void DirectKeyPress(char keyCode,long timeMs) {
	INPUT i;
	i.type = INPUT_KEYBOARD;

	i.ki.wVk = 0;
	i.ki.wScan = keyCode;
	i.ki.dwFlags = KEYEVENTF_SCANCODE;

	SendInput(1,&i,sizeof(INPUT));

	Sleep(timeMs);

	i.ki.dwFlags = KEYEVENTF_SCANCODE | KEYEVENTF_KEYUP;
	SendInput(1,&i,sizeof(INPUT));
}
void MacroKeyPress(char keyCode,long timeMs) {
	INPUT i;
	i.type = INPUT_KEYBOARD;

	i.ki.wVk = keyCode;
	i.ki.dwFlags = 0;

	SendInput(1,&i,sizeof(INPUT));

	Sleep(timeMs);

	i.ki.dwFlags = KEYEVENTF_KEYUP;
	SendInput(1,&i,sizeof(INPUT));
}
void SendMouseClick(HWND targ, int x, int y) {
	SendMessage(targ,WM_LBUTTONDOWN,MK_LBUTTON,MAKELPARAM(x,y));
	Sleep(20);
	SendMessage(targ,WM_LBUTTONUP,MK_LBUTTON,MAKELPARAM(x,y));
}
void SendKeyPress(HWND targ, char keyCode, long timeMs) {
	SendMessage(targ,WM_KEYDOWN,keyCode,0);
	Sleep(timeMs);
	SendMessage(targ,WM_KEYUP,keyCode,0);
}
void SendKeyDown(HWND targ, char keyCode) {
	SendMessage(targ,WM_KEYDOWN,keyCode,0);
}
void SendKeyUp(HWND targ, char keyCode) {
	SendMessage(targ,WM_KEYUP,keyCode,0);
}