#include "Main.h"
#include "Hack.h"
#include <stdio.h>
#include <conio.h>

HHOOK kHook;
LRESULT CALLBACK OnKeyType(int nCode, WPARAM wParam, LPARAM lParam);

Keys *keys;
Macro *currThread;
int currState;

void MsgThread() {
	MSG msg;
	while (GetMessage(&msg,0,0,0) != 0) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
}

void WINAPI ScriptThread() {
	while (true) {
		if (currThread != nullptr) {
			RunStatement(&currThread->script[currState]);
			
			currState++;
			if (currState == currThread->numStatements) {
				currThread = nullptr;
			}
		}

		Sleep(10);
	}
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrev, LPSTR args, int nCmdShow) {
	AllocConsole();
	AttachConsole(GetCurrentProcessId()) ;
	freopen("CON", "w", stdout);


	keys = new Keys();
	LoadKeyBindings();
	if (numBindings == 0) {
		return 0;
	}
	LoadMacros();

	kHook = SetWindowsHookEx(WH_KEYBOARD_LL,OnKeyType,0,0);
	CreateThread(0,0,(LPTHREAD_START_ROUTINE)ScriptThread,0,0,0);

	printf("\nSuccesfully loaded MoControl with %d different key bindings\nThank you for using MoControl!",numBindings);

	MsgThread();
	
	return 0;
}



LRESULT CALLBACK OnKeyType(int nCode, WPARAM wParam, LPARAM lParam) {
	if (nCode == HC_ACTION && wParam == WM_KEYDOWN) {
		int i = numBindings;
		while (i) {
			i--;
			if (((tagKBDLLHOOKSTRUCT*)lParam)->vkCode == macroKeys[i]) {
				RunMacro(&threads[i]);
			}
		}
	}

	return CallNextHookEx(kHook,nCode,wParam,lParam);
}


void LoadKeyBindings() {
	printf("Loading keybindings.ini...\n");

	FILE *fp = fopen("keybindings.ini","r");
	if (fp == 0) {
		numBindings = 0;
		return;
	}

	numBindings = 0;
	while (!feof(fp)) {
		char *bindStr = new char[64];
		fgets(bindStr,64,fp);

		int bindLen = 0;
		int macroLen = 0;
		int currC = 0;
		while (currC != 64) {
			if (bindLen == 0) {
				if (bindStr[currC] == '=') {
					bindLen = currC;
				}
			} else {
				if (bindStr[currC] == '\n' || bindStr[currC] == '\0') {
					macroLen = currC;
					break;
				}
			}

			currC++;
		}

		bindings[numBindings] = new char[64];
		memset(bindings[numBindings],'\0',64);
		macros[numBindings] = new char[64];
		memset(macros[numBindings],'\0',64);
		for (currC = 0; currC < bindLen; currC++) {
			bindings[numBindings][currC] = bindStr[currC];
		}

		int currMacroChar = 0;
		for (currC = bindLen+1; currC < macroLen; currC++) {
			macros[numBindings][currMacroChar] = bindStr[currC];
			currMacroChar++;
		}

		printf("Loading %s to %s key\n",macros[numBindings],bindings[numBindings]);


		delete bindStr;
		numBindings++;
	}

	fclose(fp);


	//load macro keys
	for (int i = 0; i < numBindings; i++) {
		macroKeys[i] = keys->FindKeyCode(bindings[i],64);
	}
}


void LoadMacros() {
	printf("\nLoading macros...\n");

	for (int i = 0; i < numBindings; i++) {
		printf("Compiling %s..\n",macros[i]);

		FILE *f = fopen(macros[i],"r");

		int nLines = 0;
		char *lines[512];
		while (!feof(f)) {
			lines[nLines] = new char[256];
			fgets(lines[nLines],256,f);
			if (lines[nLines][0] != '/' && lines[nLines][0] != '\n' && lines[nLines][0] != '\r') {
				nLines++;
			}
		}

		fclose(f);

		threads[i].script = new MacroStatement[nLines];
		threads[i].numStatements = nLines;
		for (int k = 0; k < nLines; k++) {
			char funcStr[64];
			memset(funcStr,'\0',64);
			char argsStr[6][64];
			memset(argsStr,'\0',384);

			char status = 0;
			char cA = 0;
			char cAC = 0;
			char cC = 0;
			char c = 0;
			while (c != 256) {
				if (lines[k][c] == '\0') {
					break;
				}

				switch (status) {
				case 0:
					if (lines[k][c] == '(') {
						cC = 0;
						status = 1;
						break;
					}
					funcStr[cC] = lines[k][c];
					cC++;
					break;

				case 1:
					if (lines[k][c] == ',') {
						argsStr[cA][cAC] = '\0';
						cA++;
						cC++;
						cAC = 0;
						break;
					}
					if (lines[k][c] == ')') {
						argsStr[cA][cAC] = '\0';
						cC = 63;
						break;
					}

					argsStr[cA][cAC] = lines[k][c];
					cC++;
					cAC++;
					break;
				}

				c++;
			}

			ParseMacro(funcStr,argsStr,&threads[i].script[k]);
		}
	}
}

char *FunctionNames[14] = {
	"SetMousePosition",
	"TweenMousePosition",
	"LeftClick",
	"RightClick",
	"MouseDown",
	"MouseUp",
	"HoldKey",
	"KeyDown",
	"KeyUp",
	"Wait",
	"SaveMousePosition",
	"RestoreMousePosition",
	"WobbleMousePosition",
	"MoveMouse"
};
void ParseMacro(char *funcStr, char args[6][64], MacroStatement *destination) {
	memcpy(destination->arguments,args,384);

	//find id
	int i = 14;
	while (i) {
		i--;
		if (memcmp(funcStr,FunctionNames[i],sizeof(FunctionNames[i])-1) == 0) {
			destination->id = i;
			return;
		}
	}
	destination->id = 255;
}


void WobbleMouseMove(MacroStatement *state) {
			int nWobbles = atoi(state->arguments[2]),tX = atoi(state->arguments[0]),tY = atoi(state->arguments[1]);
			long timeLeft = atoi(state->arguments[4]);
			int minTime = timeLeft/nWobbles-25;
			int wobbleAm = atoi(state->arguments[3]);
			int timeSeg;

			POINT currPos;
			GetCursorPos(&currPos);

			int dX = (tX-currPos.x)/nWobbles;
			int dY = (tY-currPos.y)/nWobbles;
			
			for (int i = 0; i < nWobbles-1; i++) {
				timeSeg = rand()%50+minTime;
				MacroMouseMove(currPos.x+(dX*(i+1))+rand()%wobbleAm-(wobbleAm/2),currPos.y+(dY*(i+1))+rand()%wobbleAm-(wobbleAm/2),timeSeg);
				timeLeft -= timeSeg;
			}
			MacroMouseMove(tX,tY,timeLeft);
}


void RunMacro(Macro *m) {
	currThread = m;
	currState = 0;
}
int t1,t2,t3,t4,t5;
void RunStatement(MacroStatement *state) {
	switch (state->id) {
		case 0:
			//SetMousePosition(int x, int y)
			MacroMousePos(atoi(state->arguments[0]),atoi(state->arguments[1]));
			break;

		case 1:
			//TweenMousePosition(int x, int y, long timeInMilliseconds)
			MacroMouseMove(atoi(state->arguments[0]),atoi(state->arguments[1]),atoi(state->arguments[2]));
			break;

		case 2:
			//LeftClick(long timeInMilliseconds)
			MacroMouseClick(0,atoi(state->arguments[0]));
			break;

		case 3:
			//RightClick(long timeInMilliseconds)
			MacroMouseClick(2,atoi(state->arguments[0]));
			break;

		case 4:
			//MouseDown(char button) - 0 = left, 1 = middle, 2 = right
			MacroMouseButtonDown(atoi(state->arguments[0]));
			break;

		case 5:
			//MouseUp(char button) - 0 = left, 1 = middle, 2 = right
			MacroMouseButtonUp(atoi(state->arguments[0]));
			break;

		case 6:
			//HoldKey(char asciiKeyCode, long timeInMilliseconds)
			MacroKeyPress(atoi(state->arguments[0]),atoi(state->arguments[1]));
			break;

		case 7:
			//KeyDown(char asciiKeyCode)
			MacroKeyDown(atoi(state->arguments[0]));
			break;

		case 8:
			//KeyUp(char asciiKeyCode)
			MacroKeyUp(atoi(state->arguments[0]));
			break;

		case 9:
			//Wait(long timeInMilliseconds)
			Sleep(atoi(state->arguments[0]));
			break;

		case 10:
			//SaveMousePosition()
			POINT p;
			GetCursorPos(&p);
			t4 = p.x;
			t5 = p.y;
			break;

		case 11:
			//RestoreMousePosition()
			MacroMouseMove(t4,t5,250);
			break;

		case 12:
			//WobbleMousePosition(int x, int y, int numWobbles, int wobbleAmount, long timeMs)
			WobbleMouseMove(state);
			break;

		case 13:
			//MoveMouse(int xMove, int yMove, long timeMs)
			POINT currMovePoint;
			GetCursorPos(&currMovePoint);
			MacroMouseMove(currMovePoint.x+atoi(state->arguments[0]),currMovePoint.y+atoi(state->arguments[1]),atoi(state->arguments[2]));
			break;
	}
}





Keys::Keys() {
	for (int i = 0; i < 256; i++) {
		this->KeyNames[i] = "00000";
	}

	this->KeyNames[0x8] = "backspace";
	this->KeyNames[0x9] = "tab";
	this->KeyNames[0xd] = "enter";
	this->KeyNames[0x14] = "caps-lock";
	this->KeyNames[0x1b] = "escape";
	this->KeyNames[0x20] = "space";
	this->KeyNames[0x23] = "end";
	this->KeyNames[0x24] = "home";
	this->KeyNames[0x25] = "left";
	this->KeyNames[0x26] = "up";
	this->KeyNames[0x27] = "right";
	this->KeyNames[0x28] = "down";
	this->KeyNames[0x2d] = "insert";
	this->KeyNames[0x2e] = "delete";
	this->KeyNames[0x30] = "0";
	this->KeyNames[0x31] = "1";
	this->KeyNames[0x32] = "2";
	this->KeyNames[0x33] = "3";
	this->KeyNames[0x34] = "4";
	this->KeyNames[0x35] = "5";
	this->KeyNames[0x36] = "6";
	this->KeyNames[0x37] = "7";
	this->KeyNames[0x38] = "8";
	this->KeyNames[0x39] = "9";
	this->KeyNames[0x41] = "A";
	this->KeyNames[0x42] = "B";
	this->KeyNames[0x43] = "C";
	this->KeyNames[0x44] = "D";
	this->KeyNames[0x45] = "E";
	this->KeyNames[0x46] = "F";
	this->KeyNames[0x47] = "G";
	this->KeyNames[0x48] = "H";
	this->KeyNames[0x49] = "I";
	this->KeyNames[0x4a] = "J";
	this->KeyNames[0x4b] = "K";
	this->KeyNames[0x4c] = "L";
	this->KeyNames[0x4d] = "M";
	this->KeyNames[0x4e] = "N";
	this->KeyNames[0x4f] = "O";
	this->KeyNames[0x50] = "P";
	this->KeyNames[0x51] = "Q";
	this->KeyNames[0x52] = "R";
	this->KeyNames[0x53] = "S";
	this->KeyNames[0x54] = "T";
	this->KeyNames[0x55] = "U";
	this->KeyNames[0x56] = "V";
	this->KeyNames[0x57] = "W";
	this->KeyNames[0x58] = "X";
	this->KeyNames[0x59] = "Y";
	this->KeyNames[0x5a] = "Z";
	this->KeyNames[0x60] = "num0";
	this->KeyNames[0x61] = "num1";
	this->KeyNames[0x62] = "num2";
	this->KeyNames[0x63] = "num3";
	this->KeyNames[0x64] = "num4";
	this->KeyNames[0x65] = "num5";
	this->KeyNames[0x66] = "num6";
	this->KeyNames[0x67] = "num7";
	this->KeyNames[0x68] = "num8";
	this->KeyNames[0x69] = "num9";
	this->KeyNames[0x6a] = "*";
	this->KeyNames[0x6b] = "+";
	this->KeyNames[0x6d] = "-";
	this->KeyNames[0x6e] = ".";
	this->KeyNames[0x6f] = "/";
	this->KeyNames[0x70] = "f1";
	this->KeyNames[0x71] = "f2";
	this->KeyNames[0x72] = "f3";
	this->KeyNames[0x73] = "f4";
	this->KeyNames[0x74] = "f5";
	this->KeyNames[0x75] = "f6";
	this->KeyNames[0x76] = "f7";
	this->KeyNames[0x77] = "f8";
	this->KeyNames[0x78] = "f9";
	this->KeyNames[0x79] = "f10";
	this->KeyNames[0x80] = "f11";
	this->KeyNames[0x81] = "f12";
	this->KeyNames[0xa0] = "shift-left";
	this->KeyNames[0xa1] = "shift-right";
	this->KeyNames[0xa2] = "ctrl-left";
	this->KeyNames[0xa3] = "ctrl-right";
	this->KeyNames[0xa4] = "alt-left";
	this->KeyNames[0xa5] = "alt-right";
}

char Keys::FindKeyCode(char *str, int strLen) {
	int i = 256;
	while (i != 0) {
		i--;
		
		//printf("%s",this->KeyNames[i]);
		if (memcmp(this->KeyNames[i],"00000",5) != 0) {
			if (memcmp(str,this->KeyNames[i],sizeof(this->KeyNames[i])) == 0) {
				return i;
			}
		}
	}

	return -1;
}